 /*
    Peter's Picross - A remake for TI 68k-based calculators of the Nintendo Gameboy game, "Mario's Picross"
    Copyright (C) 2008  Peter Fernandes
    supersonicandtails@gmail.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    
    
    engine.h: include for engine.c
*/


#define SAVE_STATE \
if(!unarchive_settings()) { \
	screen=settings_file+21; \
	strcpy(screen,puzzle->filename); \
	screen+=9; \
	*(((short *)screen)++)=seconds; \
	memcpy(screen,board_cleared,15*sizeof(unsigned short)); \
	screen+=15*sizeof(unsigned short); \
	memcpy(screen,board_marked,15*sizeof(unsigned short)); \
	if(settings_file_isarchived) { \
		archive_settings(); \
	} \
}


enum {MODE_PLAY, MODE_EDIT, MODE_RESTORE};


extern void draw_row_quadrupled(short x, short y, short row, short width);

extern void seconds2str(short seconds, char *buf);

extern short line_boundary(PUZZLE *puzzle, short offset);

extern void calc_numbers(PUZZLE *puzzle);

extern inline short check_solved(PUZZLE *puzzle, unsigned short *check);

extern void draw_board(PUZZLE *puzzle);

extern short main_loop(PUZZLE *puzzle, short mode, short *buf);

extern void update_board(PUZZLE *puzzle, unsigned short *board_cleared, unsigned short *board_marked, short offset);

